import org.opencv.core.Mat;
import org.opencv.core.MatOfPoint;
import org.opencv.imgproc.Imgproc;

import java.awt.image.BufferedImage;
import java.util.ArrayList;

import static org.opencv.imgproc.Imgproc.findContours;
import static org.opencv.imgproc.Imgproc.threshold;

public class BorderDetectorWorker implements Runnable {

  private BufferedImage mask;

  public void setMask(BufferedImage mask) {
    this.mask = mask;
  }

  public void borderField(BufferedImage mask) {
    MyOpenCvUtils.init();
    Mat grayMat = MyOpenCvUtils.toGreyMat(mask);
    findContours(grayMat, new ArrayList<MatOfPoint>(), new Mat(), Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_NONE);
    threshold(grayMat, grayMat, 1, 255, Imgproc.THRESH_BINARY);
  }

  @Override
  public void run() {
    int i = 0;
    String threadName = Thread.currentThread().getName();
    while (true) {
      i++;
      borderField(mask);
      if (i % 10000 == 0) {
        System.out.println(threadName + " , iterations done: " + i);
      }
    }
  }

}
