
import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.*;

public class ImageLoader {

  public BufferedImage loadFromFs(String absolutePath) {
    File file = new File(absolutePath);
    return readFromFileWrapper(file);
  }

  private BufferedImage readFromFileWrapper(File file) {
    try {
      FileInputStream fileInputStream = new FileInputStream(file);
      return buildFromStream(fileInputStream);
    } catch (FileNotFoundException e) {
      throw new RuntimeException(e);
    }
  }

  private BufferedImage buildFromStream(InputStream is) {
    try {
      BufferedImage src = ImageIO.read(is);
      is.close();
      return MyOpenCvUtils.convert(src, BufferedImage.TYPE_INT_RGB);
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
  }



}

